//+------------------------------------------------------------------+
//|                                                      Chicken.mq4 |
//|                                        CopyLeft  2009, mql4com  |
//|                                   http://forum.mql4.com/ru/18803 |
//|               Last modification by Yury V. Reshetov, 16 yan 2009 |
//+------------------------------------------------------------------+
#property copyright "CopyLeft  2009, mql4com, http://forum.mql4.com/ru/18803"
#property link      "http://forum.mql4.com/ru/18803"

extern bool Limits = TRUE; // TRUE - LIMIT orders; FALSE - STOP orders
extern double Distance = 10; // Probably less than zero
extern double TP = 98;
extern double SL = 10;
extern double TralSL = 29;
extern double Lots = 0.01;
static int PrevTime = 0;

double Spread = 3.0;

void init()
{
  Distance *= Point;
  TP *= Point;
  SL *= Point;
  TralSL *= Point;
  PrevTime = Time[0];
  Spread = Point * MarketInfo(Symbol(), MODE_SPREAD);
  
  return;
}

void TrailingOrders()
{
  int i, Total = OrdersTotal();
  double Difference, tp, sl;
  
  for (i = 0; i < Total; i++)
  {
    OrderSelect(i, SELECT_BY_POS);
   
    if (OrderType() == OP_BUY)
    {
      sl = Bid - TralSL;
      Difference = NormalizeDouble(sl - OrderStopLoss(), Digits);
        
      if (Difference > 0)
      {
        sl = NormalizeDouble(sl, Digits);
        
        if (! OrderModify(OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0)) {
         PrevTime = Time[1];
        }
        Sleep(30000);
      }
    }
    else if (OrderType() == OP_SELL)
    {
      sl = Ask + TralSL;
      Difference = NormalizeDouble(sl - OrderStopLoss(), Digits);
        
      if (Difference < 0)
      {
        sl = NormalizeDouble(sl, Digits);
       
        if (! OrderModify(OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0)) {
         PrevTime = Time[1];
        }
        Sleep(30000);
      }
    }
  }
  
  return;
}

bool OrderScan( int TypeOrder )
{
  int i, Total = OrdersTotal();
  
  for (i = 0; i < Total; i++)
  {
    OrderSelect(i, SELECT_BY_POS);
    
    if (OrderType() == TypeOrder)
      return(TRUE);
  }
  
  return(FALSE);
} 

void MyOrderSend( int TypeOrder, double open, double sl, double tp )
{
  if (OrderScan(TypeOrder)) {
    if (! OrderModify(OrderTicket(), open, sl, tp, 0)) {
         PrevTime = Time[1];
    }
    Sleep(30000);
    
  } else {
    int ticket = OrderSend(Symbol(), TypeOrder, Lots, open, 0, sl, tp);
    if (ticket < 0) {
         PrevTime = Time[1];
    }
    Sleep(30000);
  }
      
  return;
}

void OpenOrders( double H, double L )
{
  double open, tp, sl;
  
  if (Limits)
  {
    if (!OrderScan(OP_BUY))
    {
      open = NormalizeDouble(L - Distance + Spread, Digits);
      tp = NormalizeDouble(open + TP, Digits);
      sl = NormalizeDouble(open - SL, Digits);
  
      MyOrderSend(OP_BUYLIMIT, open, sl, tp);
    }
  
    if (!OrderScan(OP_SELL))
    {
      open = NormalizeDouble(H + Distance, Digits);
      tp = NormalizeDouble(open - TP, Digits);
      sl = NormalizeDouble(open + SL, Digits);
  
      MyOrderSend(OP_SELLLIMIT, open, sl, tp);
    }
  }
  else
  {
    if (!OrderScan(OP_BUY))
    {
      open = NormalizeDouble(H + Distance + Spread, Digits);
      tp = NormalizeDouble(open + TP, Digits);
      sl = NormalizeDouble(open - SL, Digits);
  
      MyOrderSend(OP_BUYSTOP, open, sl, tp);
    }

    if (!OrderScan(OP_SELL))
    {
      open = NormalizeDouble(L - Distance, Digits);
      tp = NormalizeDouble(open - TP, Digits);
      sl = NormalizeDouble(open + SL, Digits);
  
      MyOrderSend(OP_SELLSTOP, open, sl, tp);
    }
  }
  
  return;
}

void start()
{

   if (! IsTradeAllowed()) {
      return(0);
   }

  TrailingOrders();
  
  if (PrevTime == Time[0])
    return;
    
  PrevTime = Time[0];
  
  OpenOrders(High[1], Low[1]);
  
  return;
}